//
//  SMInterfaceInspectorRemote.h
//  InterfaceInspectorRemote
//
//  Created by Stephan Michels on 03.04.13.
//  Copyright (c) 2013 Stephan Michels. All rights reserved.
//

#import <Foundation/Foundation.h>

@class SMServiceBrowser;

@interface SMInterfaceInspectorRemote : NSObject {
	SMServiceBrowser *_browser;
	NSMutableArray *_clients;
	NSMutableArray *_resolvedClients;
	NSMutableArray *_connectedClients;
	BOOL _started;
	BOOL _selectionMode;
	NSMapTable *_overlayWindows;
}

@property (nonatomic, getter = isStarted, readonly) BOOL started;

+ (instancetype)sharedInstance;

- (void)start;
- (void)stop;

@end

__attribute__((constructor))
static void initialize_InterfaceInspector() {
	SMInterfaceInspectorRemote *server = [SMInterfaceInspectorRemote sharedInstance];
	if (!server.started) {
		[server start];
	}
}

__attribute__((destructor))
static void destroy_InterfaceInspector() {
	SMInterfaceInspectorRemote *server = [SMInterfaceInspectorRemote sharedInstance];
	if (server.started) {
		[server stop];
	}
}